﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace External
{
    public partial class SipDemo : UserControl
    {
        public SipDemo()
        {
            InitializeComponent();

            // Fill up ListBox
            MemberInfo[] members = typeof(InputScopeNameValue).GetMembers(BindingFlags.Public | BindingFlags.Static);

            Array.Sort<MemberInfo>(members, delegate(MemberInfo mi1, MemberInfo mi2)
            {
                return String.Compare(mi1.Name, mi2.Name);
            });

            foreach (MemberInfo member in members)
                lstbox.Items.Add(member.Name);
        }

        void OnListBoxSelectionChanged(object sender, SelectionChangedEventArgs args)
        {
            if (args.AddedItems.Count != 0)
            {
                InputScopeNameValue nameValue = (InputScopeNameValue)Enum.Parse(typeof(InputScopeNameValue), args.AddedItems[0] as string, false);

                try
                {
                    inputScopeName.NameValue = nameValue;
                }
                catch
                {
                    lstbox.Items.Remove(args.AddedItems[0]);
                }
            }
        }
    }
}