﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml;
using System.Xml.Serialization;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using SlideShowElement;

namespace PhoniePoint
{
    public partial class MainPage : PhoneApplicationPage
    {
        string[] styleKeys = { "slideShowIntro", "slideShowTitle", "slideShowLevel1", "slideShowLevel2", "slideShowLevel3" };
        SlideShow slideshow;
        int pageNum = -1;

        public MainPage()
        {
            InitializeComponent();
            SupportedOrientations = SupportedPageOrientation.Portrait | SupportedPageOrientation.Landscape;


            // Load in slideshow
            XmlReader reader = XmlReader.Create("Data/SlideShow.xml");
            XmlSerializer serializer = new XmlSerializer(typeof(SlideShow));
            slideshow = serializer.Deserialize(reader) as SlideShow;

    //        textBlockPageTitle2.Text = slideshow.Description;
/*
            ContentControl ctrl = new ContentControl
            {
                Background = new SolidColorBrush(Colors.Brown),


                HorizontalAlignment = System.Windows.HorizontalAlignment.Stretch,
                VerticalAlignment = System.Windows.VerticalAlignment.Stretch
            };
*/

            StackPanel stack = new StackPanel();
            stack.VerticalAlignment = System.Windows.VerticalAlignment.Center;

            TextBlock txtblk = new TextBlock
            {
                Text = slideshow.Title + "\r\n\x2014",
                Style = this.Resources[styleKeys[0]] as Style
            };
      //      ctrl.Content = txtblk;

//            ContentGrid.Children.Add(ctrl);

            stack.Children.Add(txtblk);

            txtblk = new TextBlock
            {
                Text = slideshow.Name,
                Style = this.Resources[styleKeys[1]] as Style,
                TextWrapping = TextWrapping.Wrap
            };

            stack.Children.Add(txtblk);
            ContentGrid.Children.Add(stack);
        }

        void ShowPage(int pageNum)
        {
            Slide slide = slideshow.Slides[pageNum];

            if (String.IsNullOrEmpty(slide.Control))
            {
                ContentControl ctrl = new ContentControl();
                StackPanel stack = new StackPanel();
            //    stack.Background = new SolidColorBrush(Colors.Brown);
                stack.HorizontalAlignment = System.Windows.HorizontalAlignment.Stretch;

                // Why should I need to do this????
                stack.Width = 480;

                ctrl.Content = stack;

                TextBlock txtblk = new TextBlock
                {
                    Text = slide.Title,
                    Style = this.Resources[styleKeys[1]] as Style
                };

                stack.Children.Add(txtblk);

                AddLevels(stack, slide.Items, 2);

                ContentGrid.Children.Clear();
                ContentGrid.Children.Add(ctrl);
                this.ApplicationBar.Opacity = 0;
            }
            else
            {
                Assembly assembly = Assembly.GetCallingAssembly();
                Type type = assembly.GetType(slide.Control);
                ConstructorInfo constructor = type.GetConstructor(Type.EmptyTypes);
                UIElement element = constructor.Invoke(null) as UIElement;

                ContentGrid.Children.Clear();
                ContentGrid.Children.Add(element);
                this.ApplicationBar.Opacity = 1;
            }
        }

        void AddLevels(Panel pnl, List<Item> items, int styleKeyNum)
        {
            if (items == null || items.Count == 0)
                return;

            foreach (Item item in items)
            {
                TextBlock txtblk = new TextBlock
                {
                    Text = item.Text,
                    Style = this.Resources[styleKeys[styleKeyNum]] as Style
                };
                pnl.Children.Add(txtblk);

                AddLevels(pnl, item.SubItems, styleKeyNum + 1);
            }
        }

        void EnableAndDisableButtons()
        {
            // Doesn't look as if Enabled property working yet,
            //  Also, that buttons can't be referred to by name!

            (this.ApplicationBar.Buttons[1] as ApplicationBarItem).Enabled = 
        //    appBarBackButton.Enabled = 
                (pageNum > 0);

            (this.ApplicationBar.Buttons[2] as ApplicationBarItem).Enabled = 
        //    appBarNextButton.Enabled = 
                (pageNum < slideshow.Slides.Count - 1);
        }

        void OnAppBarBegClick(object sender, EventArgs args)
        {
            ShowPage(pageNum = 0);
            EnableAndDisableButtons();
        }

        void OnAppBarBackClick(object sender, EventArgs args)
        {
            if (pageNum == 0)
                return;

            ShowPage(--pageNum);
            EnableAndDisableButtons();
        }

        void OnAppBarNextClick(object sender, EventArgs args)
        {
            if (pageNum == slideshow.Slides.Count - 1)
                return;

            ShowPage(++pageNum);
            EnableAndDisableButtons();
        }

        void OnAppBarEndClick(object sender, EventArgs args)
        {
            ShowPage(pageNum = slideshow.Slides.Count - 1);
            EnableAndDisableButtons();
        }
    }
}